///gtk1 calender analog to xcalendar.
///gointnuts 2018

//compatible fileformat with xcalendar "xc18Mar2018"	TODO
//if save but no text - do not create savefile (?)	TODO

#include <gtk/gtk.h>
#include <gdk/gdkkeysyms.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <sys/stat.h>
#include <time.h>
#include <sys/dir.h>
#include <sys/stat.h>
#include <errno.h>

extern int errno;

typedef struct _CalendarData {
	GtkWidget *window;
} CalendarData;

static GtkWidget *calendar;
static GtkWidget *text;
char *homedir = NULL;
char calendarDir[256];
char filename[256];
char myselect[7];

static GtkWidget *save_button;

gboolean on_key_press (GtkWidget *widget, GdkEventKey *event, gpointer user_data) {
	
	switch (event->keyval) {

	case GDK_Tab:
		g_print("key pressed: %s\n", "tab");
		gtk_widget_grab_focus (save_button);
		break;

    default:
      return FALSE; 
  }

  return FALSE; 
}


int print_files() {

	DIR           *d;
	struct dirent *dir;
   
	sprintf(myselect, "%.*s", 7, filename + 3);

	char myday[3];
   
	d = opendir(calendarDir);

	if (d) {
		while ((dir = readdir(d)) != NULL) {

			if(strstr(dir->d_name, myselect) != NULL) {
				strncpy(myday, dir->d_name, 2);
				gtk_calendar_mark_day( GTK_CALENDAR(calendar), atoi(myday));
			}
		}
    closedir(d);
	}

  return(0);
}

///init gcalendar
int Initialize (){
	char *getenv();
	int                  error_status;
	struct stat          dir_status;
	DIR                  *dirp;
	
	///Open the ~/Calendar directory - create if necessary
	homedir = getenv("HOME");
	strcpy(calendarDir,homedir);
	strcat(strcat(calendarDir,"/"),"Calendar");
	
	error_status = stat(calendarDir,&dir_status);

	if(error_status == -1) {
		if(errno == ENOENT){ //not found
			printf("%s doesn't exist : Creating...\n", calendarDir);
			if( mkdir(calendarDir,0700) == -1 ){
				printf("Couldn't create ~/Calendar directory.\n");
				return 1;
			}
		} else {
      		printf("Cannot stat ~/Calendar directory");
			return 1;
		}
	}
	chdir(calendarDir);

	dirp = (DIR *) opendir(calendarDir);

	if(dirp == NULL) {
		printf("Cannot open  ~/Calendar (maybe it's not a directory)\n");
		return 1;
	}
	
	///Set todays filename and initialize mydate_glob
	time_t rawtime;
	struct tm * timeinfo;
	
	time (&rawtime);
	timeinfo = localtime (&rawtime);

	strftime (filename, 80, "%d_%m_%Y", timeinfo);

	return 0;
	
}

///Get the text from the widget.
char *GetText () {
	
    char *buffer;

    ///Get the string from the widget
    buffer = gtk_editable_get_chars (GTK_EDITABLE (text), 
		(gint) 0, (gint) gtk_text_get_length (GTK_TEXT (text)));
 
    return (buffer);
}

///Delete file
int DeleteFile () {
	
	int status;
	status = remove(filename);
	
	if (status == 0) {
		printf("%s file deleted successfully.\n", filename);
	} else {
		printf("Unable to delete the file %s\n", filename);
	}

	///gtk_calendar_unmark_day
	char myday[3]; 
	strncpy(myday, filename, 2);
	
	gtk_calendar_unmark_day( GTK_CALENDAR(calendar), atoi(myday));
 
	return 0;
	
}

void ClearText () {
	
	///Empty the widget
    gtk_editable_delete_text (GTK_EDITABLE (text), 0, -1);
    
	///Delete the file
	DeleteFile();
	
}

///LoadFile
int LoadFile (char *sFilename) {
	
    char buffer[256];
    int nchars;
    FILE *infile;
    struct stat fileStatus;
    long fileLen = 0;

    ///Freeze the widget
    gtk_text_freeze (GTK_TEXT (text));

    ///Empty the widget
    gtk_editable_delete_text (GTK_EDITABLE (text), 0, -1);

    ///Get file information
    stat (sFilename, &fileStatus);
    fileLen = fileStatus.st_size;

    ///Open the file
    infile = fopen (sFilename, "r");
      
    ///If we open the file
    if (infile) {
      
        ///Read a chunk
        while ((nchars = fread (buffer, 1, 256, infile)) > 0) {

            ///Insert the text
            gtk_text_insert (GTK_TEXT (text), NULL, NULL,
                   NULL, buffer, nchars);
          
            ///Less than buffer means EOF
            if (nchars < 256)
                break;
        }
      
        ///Close file
        fclose (infile);
        ///Un-freeze the text widget - it'll repaint now
        gtk_text_thaw (GTK_TEXT (text));
        return 1;
        
    } else {
    	///Un-freeze the text widget - it'll repaint now
    	gtk_text_thaw (GTK_TEXT (text));
    	return 0;
	}

}

///Save the file.
void SaveFile () {

	char *s = filename;

    FILE *outfile;
    char *buffer;
    int nchars;

    ///Open the file
    outfile = fopen (s, "w");
      
    if (outfile) {
      
        ///Get the string from the widget
        buffer = GetText ();

        ///Write the buffer to disk
        nchars = fwrite (buffer, sizeof (char), strlen (buffer), outfile);
 
        ///Close the file
        fclose (outfile);

        if (nchars != strlen (buffer)) {
           printf("Save: Can't write file.");
        }
        ///Free up the memory
        g_free (buffer);

    } else {
        printf("Can't save file: %s\n", s);
    }
    ///gtk_calendar_mark_day    
    char myday[3]; 
	strncpy(myday, s, 2);
	
	gtk_calendar_mark_day( GTK_CALENDAR(calendar), atoi(myday));
}

///GtkCalendar
void calendar_date_to_string( CalendarData *data, char *buffer, gint buff_len ) {
  
	struct tm tm;
	time_t time;

	memset (&tm, 0, sizeof (tm));
	gtk_calendar_get_date (GTK_CALENDAR(data->window),
		(guint*)&tm.tm_year, (guint*)&tm.tm_mon, (guint*)&tm.tm_mday);

	tm.tm_year -= 1900;
	time = mktime(&tm);

	strftime (buffer, buff_len-1, "%d_%m_%Y", gmtime(&time));
	
}

void calendar_day_selected( GtkWidget *widget, CalendarData *data ) {
	
	calendar_date_to_string (data, filename, 256);
	LoadFile(filename);
}


void calendar_month_changed( GtkWidget *widget, CalendarData *data ) {
	
	calendar_date_to_string (data, filename, 256);
	gtk_calendar_clear_marks( GTK_CALENDAR(calendar) );
	print_files();
}

int mydate (){
	
	time_t t = time(NULL);
	struct tm tm = *localtime(&t);
	return tm.tm_mday;	
}


/// for dnd
static GtkTargetEntry target_table[] = {
	{ "text/uri-list", 0, 0 },
};

/// for dnd - type of file referred to. 0=unknown/nothing, 1=file, 2=dir.
gint filetype(char *file) {
	struct stat st;
	if ((!file) || (!*file)) return 0;
	if (stat(file, &st) < 0) return 0;
	if (S_ISREG(st.st_mode)) return 1;
	if (S_ISDIR(st.st_mode)) return 2;
	return 0;
}

/// for dnd
void add_file(const gchar *initname) {
	
	///clear the text
	gtk_text_set_point(GTK_TEXT(text), 0 );
	gtk_text_forward_delete(GTK_TEXT(text),
		gtk_text_get_length(GTK_TEXT(text)) );
	
	///then open the file in the editor
	LoadFile ((char*)initname);
	
}

/// for dnd - handle files dropped on our window. */
void handle_dnd_drop(GtkWidget *widget, GdkDragContext *context, gint x, gint y, GtkSelectionData *data, guint info, guint time, gpointer user_data) {
	
	if (data->data) {
	/* The format of data->data is a list of URIs, seperated by
       and terminating in \r\n. We're only interested in the file:
       URIs.

       The URIs can look like "file:///home/azz/x" (from ROX-Filer in
       non-hostname mode), "file://myhost.org/home/azz/x" (from
       ROX-Filer in hostname mode), or "file:/home/azz/x" (from
       Konqueror). */
		gchar *s = strdup((const char *) data->data), *p, *q;

		p = s;
		while ((q = strchr(p, '\r'))) {
			char *file;

			*q = '\0';
			if (!(*++q == '\n')) break;
			*q = '\0';

			file = NULL;
			if (strncmp(p, "file://", 7) == 0) {
				file = strchr(p + 7, '/');
 			} else if (strncmp(p, "file:", 5) == 0) {
				file = p + 5;
			}

			if (file != NULL) {
				if (filetype(file) != 2) {
					add_file(file);
				}
      		}
      		p = q + 1;
		}
    	g_free(s);
	}   
}

void create_calendar() {

	GtkWidget *main_window;
	GtkWidget *vbox;
	GtkWidget *hbox;
	GtkWidget *vbox2;
	GtkWidget *close_button;
	GtkWidget *clear_button;
	GtkWidget *frame;
	GtkWidget *bbox;
	GtkWidget *Scrolledwindow;
    
	static CalendarData calendar_data;
  
	calendar_data.window = NULL;

	main_window = gtk_window_new (GTK_WINDOW_TOPLEVEL);

	gtk_window_set_title(GTK_WINDOW(main_window), "gcalendar-0.1");

	gtk_container_border_width (GTK_CONTAINER (main_window), 5);
	
	gtk_signal_connect(GTK_OBJECT(main_window), "destroy",
		GTK_SIGNAL_FUNC(gtk_main_quit), NULL);
	gtk_signal_connect(GTK_OBJECT(main_window), "delete-event",
		GTK_SIGNAL_FUNC(gtk_false), NULL);

	gtk_window_set_policy(GTK_WINDOW(main_window), FALSE, FALSE, TRUE);

	vbox = gtk_vbox_new(FALSE, 10);
	gtk_container_add (GTK_CONTAINER (main_window), vbox);

	///The top part of the window, Calendar.
	hbox = gtk_hbox_new(FALSE, 10);
	gtk_box_pack_start (GTK_BOX(vbox), hbox, TRUE, TRUE, 2);

	///Calendar widget.
	frame = gtk_frame_new("Calendar");
	gtk_box_pack_start(GTK_BOX(hbox), frame, FALSE, TRUE, 2);
	calendar = gtk_calendar_new();
	calendar_data.window = calendar;

	///Select today.
	gtk_calendar_select_day( GTK_CALENDAR(calendar), mydate());

	gtk_container_add( GTK_CONTAINER( frame), calendar);
	
	gtk_signal_connect (GTK_OBJECT (calendar), "month_changed", 
		GTK_SIGNAL_FUNC (calendar_month_changed), &calendar_data);
	
	gtk_signal_connect (GTK_OBJECT (calendar), "day_selected", 
		GTK_SIGNAL_FUNC (calendar_day_selected), &calendar_data);
	
	///Day Editor
  	frame = gtk_frame_new("Day Editor");
  	gtk_box_pack_start(GTK_BOX(hbox), frame, FALSE, TRUE, 10);

  	vbox2 = gtk_vbox_new(TRUE, 5);
  	gtk_container_add(GTK_CONTAINER(frame), vbox2);
  	
	Scrolledwindow = gtk_scrolled_window_new(NULL, NULL);
	gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(Scrolledwindow),
		GTK_POLICY_AUTOMATIC, GTK_POLICY_ALWAYS);
	gtk_box_pack_start (GTK_BOX (vbox2), Scrolledwindow, TRUE, TRUE, 0);
	gtk_widget_show (Scrolledwindow);
	gtk_widget_set_usize(Scrolledwindow, 220, 50);

	text = gtk_text_new (NULL, NULL);
	gtk_text_set_editable (GTK_TEXT (text), TRUE);
	
	///let tab key change focus
    gtk_signal_connect (GTK_OBJECT (text), "key_press_event", GTK_SIGNAL_FUNC (on_key_press), NULL); 
	
	///Listen to drag-and-drop
	gtk_signal_connect(GTK_OBJECT(text), "drag_data_received",
		GTK_SIGNAL_FUNC(handle_dnd_drop), NULL);
	gtk_drag_dest_set(text, GTK_DEST_DEFAULT_MOTION |
		GTK_DEST_DEFAULT_HIGHLIGHT | GTK_DEST_DEFAULT_DROP, target_table, 1,
		GDK_ACTION_COPY | GDK_ACTION_MOVE);
	
	gtk_container_add(GTK_CONTAINER(Scrolledwindow), text);
	
    gtk_widget_show (text);
    
	
    ///Load todays file 
    LoadFile(filename);

	///The button(s)
	bbox = gtk_hbutton_box_new ();
	gtk_box_pack_start (GTK_BOX (vbox), bbox, FALSE, FALSE, 0);
	gtk_button_box_set_layout(GTK_BUTTON_BOX(bbox), GTK_BUTTONBOX_END);
	
	close_button = gtk_button_new_with_label ("Close");
	gtk_signal_connect (GTK_OBJECT (close_button), "clicked", 
		GTK_SIGNAL_FUNC (gtk_main_quit), NULL);
	
	gtk_container_add (GTK_CONTAINER (bbox), close_button);
	
	save_button = gtk_button_new_with_label ("Save");
	gtk_signal_connect (GTK_OBJECT (save_button), "clicked", 
		GTK_SIGNAL_FUNC (SaveFile), NULL);
	
	gtk_container_add (GTK_CONTAINER (bbox), save_button);
	
	clear_button = gtk_button_new_with_label ("Clear");
	gtk_signal_connect (GTK_OBJECT (clear_button), "clicked", 
		GTK_SIGNAL_FUNC (ClearText), NULL);
	
	gtk_container_add (GTK_CONTAINER (bbox), clear_button);
	
	GTK_WIDGET_SET_FLAGS (close_button, GTK_CAN_DEFAULT);
	gtk_widget_grab_default (close_button);
	
	gtk_widget_show_all(main_window);
}


int main(int argc, char *argv[] ) {

	gtk_set_locale ();
	gtk_init (&argc, &argv);
	
	Initialize();
	
	create_calendar();
	///mark days in present month with calendarfiles
	print_files();

	gtk_main();

	return(0);
}

